--
-- DoorOpener
--
-- written by fruktor, visit: www.eifok-team.de
-- Edit by }I{EKA special for MTZ-1025

DoorOpener = {};

DoorOpener.modDir = g_currentModDirectory;

function DoorOpener.prerequisitesPresent(specializations)
    return true; 
end;

function DoorOpener:load(savegame)
--  left door
    self.playerCallbackLeftDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackLeftDoor"); 
    
    self.doorO = {};
    
    local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.leftDoorOpener#trigger")) );
    if trigger == nil then
        print("[Error::LeftDoorOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
    end;
    
    local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.leftDoorOpener#icIndex", i));
    
    self.doorO.icIndex = icIndex;
    self.doorO.trigger = trigger;
    self.doorO.plIR = false;
    
    addTrigger( trigger, "playerCallbackLeftDoor", self );
--  left Shit
    
    -- sideback doors
    self.sidebackDoors = {}
    self.numSidebackDoors = 0;
    while true do
        local key = "vehicle.sidebackDoors.sidebackDoor("..tostring(self.numSidebackDoors)..")";
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        
        self.numSidebackDoors = self.numSidebackDoors + 1;
        local sidebackDoor = {}
        sidebackDoor.animName = getXMLString(self.xmlFile, key.."#animName");
        sidebackDoor.index = self.numSidebackDoors;
        sidebackDoor.vehicle = self;
        sidebackDoor.triggerId = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#triggerIndex"));
        sidebackDoor.playerInTrigger = false;
        addTrigger(sidebackDoor.triggerId, "triggerCallback", sidebackDoor);
        
        function sidebackDoor:open()
            sidebackDoor.vehicle:playAnimation(sidebackDoor.animName, 1, 0, false);
        end;
        function sidebackDoor:close()
            sidebackDoor.vehicle:playAnimation(sidebackDoor.animName, -1, 1, false);
        end;
        
        function sidebackDoor:getIsClosed()
            return sidebackDoor.vehicle:getAnimationTime(sidebackDoor.animName) == 0;
        end;
        function sidebackDoor:getIsOpened()
            return sidebackDoor.vehicle:getAnimationTime(sidebackDoor.animName) == 1;
        end;
        
        function sidebackDoor:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
            if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
                if onEnter then
                    sidebackDoor.playerInTrigger = true;
                elseif onLeave then
                    sidebackDoor.playerInTrigger = false;
                end;
            end;
        end;
        
        self.sidebackDoors[sidebackDoor.index] = sidebackDoor;
        self.sidebackDoors[sidebackDoor.animName] = sidebackDoor;
    end;    
    self.sidebackDoorOpenSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.sidebackDoorOpen", nil, self.baseDirectory);
    self.sidebackDoorCloseSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.sidebackDoorClose", nil, self.baseDirectory);
    
    -- side doors
    self.sideDoors = {}
    self.numSideDoors = 0;
    while true do
        local key = "vehicle.sideDoors.sideDoor("..tostring(self.numSideDoors)..")";
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        
        self.numSideDoors = self.numSideDoors + 1;
        local sideDoor = {}
        sideDoor.animName = getXMLString(self.xmlFile, key.."#animName");
        sideDoor.index = self.numSideDoors;
        sideDoor.vehicle = self;
        sideDoor.triggerId = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#triggerIndex"));
        sideDoor.playerInTrigger = false;
        addTrigger(sideDoor.triggerId, "triggerCallback", sideDoor);
        
        function sideDoor:open()
            sideDoor.vehicle:playAnimation(sideDoor.animName, 1, 0, false);
        end;
        function sideDoor:close()
            sideDoor.vehicle:playAnimation(sideDoor.animName, -1, 1, false);
        end;
        
        function sideDoor:getIsClosed()
            return sideDoor.vehicle:getAnimationTime(sideDoor.animName) == 0;
        end;
        function sideDoor:getIsOpened()
            return sideDoor.vehicle:getAnimationTime(sideDoor.animName) == 1;
        end;
        
        function sideDoor:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
            if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
                if onEnter then
                    sideDoor.playerInTrigger = true;
                elseif onLeave then
                    sideDoor.playerInTrigger = false;
                end;
            end;
        end;
        
        self.sideDoors[sideDoor.index] = sideDoor;
        self.sideDoors[sideDoor.animName] = sideDoor;
    end;    
    self.sideDoorOpenSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.sideDoorOpen", nil, self.baseDirectory);
    self.sideDoorCloseSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.sideDoorClose", nil, self.baseDirectory);
end;

function DoorOpener:delete()
-- left door
    if self.doorO.trigger ~= nil then
        removeTrigger(self.doorO.trigger);
    end;
-- left Shit
    for a=1, table.getn(self.sideDoors) do
        removeTrigger(self.sideDoors[a].triggerId);
    end;
    SoundUtil.deleteSample(self.sideDoorOpenSound);
    SoundUtil.deleteSample(self.sideDoorCloseSound);
-- left Shit Back
    for a=1, table.getn(self.sidebackDoors) do
        removeTrigger(self.sidebackDoors[a].triggerId);
    end;
    SoundUtil.deleteSample(self.sidebackDoorOpenSound);
    SoundUtil.deleteSample(self.sidebackDoorCloseSound);
end;

function DoorOpener:readStream(streamId, connection)
end;

function DoorOpener:writeStream(streamId, connection)
end;

function DoorOpener:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DoorOpener:keyEvent(unicode, sym, modifier, isDown)
end;

function DoorOpener:update(dt)
    if self.doorO.plIR then
        g_currentMission:addHelpButtonText( g_i18n:getText("SET_LEFTDOOROPENER"), InputBinding.SET_DOOROPENER );    
        setTextColor(1.0, 1.0, 1.0, 1.0);
        if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
            local obj = self.interactiveObjects[self.doorO.icIndex];
            if obj ~= nil then
                self:doActionOnObject(self.doorO.icIndex);
            end;
        end
    end;
    
    if not (g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen) then
        -- side door control
        for a=1, self.numSideDoors do
            local sideDoor = self.sideDoors[a];
            if sideDoor.playerInTrigger then
                if g_currentMission.player.isEntered then
                    if sideDoor:getIsClosed() then
                        g_currentMission:addHelpButtonText(g_i18n:getText("SET_LEFTDOOROPENER"), InputBinding.SET_DOOROPENER);
                        if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                            sideDoor:open();
                            SoundUtil.playSample(self.sideDoorOpenSound, 1, 0);
                        end;
                    elseif sideDoor:getIsOpened() then
                        if (sideDoor.animName == "LeftBok" ) or sideDoor.animName ~= "LeftBok" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("closeSideDoor"), InputBinding.SET_DOOROPENER);
                            if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                                sideDoor:close();
                                SoundUtil.playSample(self.sideDoorCloseSound, 1, 0);
                            end;
                        end;
                        if (sideDoor.animName == "RightBok" ) or sideDoor.animName ~= "RightBok" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("closeSideDoor"), InputBinding.SET_DOOROPENER);
                            if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                                sideDoor:close();
                                SoundUtil.playSample(self.sideDoorCloseSound, 1, 0);
                            end;
                        end;
                    end;
                end;
            end;
        end;
    end;
    
    if not (g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen) then
        -- side door control
        for a=1, self.numSidebackDoors do
            local sidebackDoor = self.sidebackDoors[a];
            if sidebackDoor.playerInTrigger then
                if g_currentMission.player.isEntered then
                    if sidebackDoor:getIsClosed() then
                        g_currentMission:addHelpButtonText(g_i18n:getText("SET_LEFTDOOROPENER"), InputBinding.SET_DOOROPENER);
                        if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                            sidebackDoor:open();
                            SoundUtil.playSample(self.sidebackDoorOpenSound, 1, 0);
                        end;
                    elseif sidebackDoor:getIsOpened() then
                        if (sidebackDoor.animName == "LeftBokZ" ) or sidebackDoor.animName ~= "LeftBokZ" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("closeSidebackDoor"), InputBinding.SET_DOOROPENER);
                            if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                                sidebackDoor:close();
                                SoundUtil.playSample(self.sidebackDoorCloseSound, 1, 0);
                            end;
                        end;
                        if (sidebackDoor.animName == "RightBokZ" ) or sidebackDoor.animName ~= "RightBokZ" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("closeSidebackDoor"), InputBinding.SET_DOOROPENER);
                            if InputBinding.hasEvent(InputBinding.SET_DOOROPENER) then
                                sidebackDoor:close();
                                SoundUtil.playSample(self.sidebackDoorCloseSound, 1, 0);
                            end;
                        end;
                    end;
                end;
            end;
        end;
    end;
end;

function DoorOpener:onLeave()
end;

function DoorOpener:draw()
end;

function DoorOpener:playerCallbackLeftDoor(triggerId, otherId, onEnter, onLeave, onStay)
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.doorO.plIR = true;
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.doorO.plIR = false;
    end;
end;