--
-- RostselMash
-- Specialization for RostselMash
--
-- @author  Aluha74rus
-- @date  10/03/17
-- @version 1.0 - Aluha74rus-Nikol
--

RostselMash = {};

function RostselMash.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations) and SpecializationUtil.hasSpecialization(Overloading, specializations)  and SpecializationUtil.hasSpecialization(Pipe, specializations)  and SpecializationUtil.hasSpecialization(Combine, specializations) and 
           SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function RostselMash:load(savegame)
    self.startMotor = SpecializationUtil.callSpecializationsFunction("startMotor");
    self.stopMotor = SpecializationUtil.callSpecializationsFunction("stopMotor");

	
	self.U = Utils.indexToObject(self.components, "0>10|0|6|0");
	self.C = Utils.indexToObject(self.components, "0>10|0|6|1");
	self.Z = Utils.indexToObject(self.components, "0>10|0|6|2");
	
	self.UN = Utils.indexToObject(self.components, "0>10|0|7|0");
	self.CN = Utils.indexToObject(self.components, "0>10|0|7|1");
	self.ZN = Utils.indexToObject(self.components, "0>10|0|7|2");
    self.NizNSvet = Utils.indexToObject(self.components, "0>24|1");
    self.NizNSvet0 = Utils.indexToObject(self.components, "0>21|3|4");
    self.NizNSvet1 = Utils.indexToObject(self.components, "0>21|8|0|0|2");
    self.NizNSvet2 = Utils.indexToObject(self.components, "0>10|0|3");
    self.NizNSvet3 = Utils.indexToObject(self.components, "0>10|0|0|0|2");
    self.NizNSvet4 = Utils.indexToObject(self.components, "0>21|3|2|0|1");
    self.NizNSvet5 = Utils.indexToObject(self.components, "0>21|8|8|0|1");
    self.NizNSvet7 = Utils.indexToObject(self.components, "0>21|8|8|0|2");

    self.NizSvet = Utils.indexToObject(self.components, "0>24|0");
    self.NizSvet0 = Utils.indexToObject(self.components, "0>21|3|1");
    self.NizSvet1 = Utils.indexToObject(self.components, "0>21|8|0|0|1");
    self.NizSvet2 = Utils.indexToObject(self.components, "0>10|0|2");
    self.NizSvet3 = Utils.indexToObject(self.components, "0>10|0|0|0|1");
    self.NizSvet4 = Utils.indexToObject(self.components, "0>21|3|2|0|0");
    self.NizSvet5 = Utils.indexToObject(self.components, "0>21|8|8|0|1");
    self.NizSvet7 = Utils.indexToObject(self.components, "0>21|8|8|0|2");
    self.Comp = Utils.indexToObject(self.components, "0>23");
    self.CompPribors = Utils.indexToObject(self.components, "0>21|12");
	
	self.gearShifter = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.gearShifter#index"));
    
    self.KlawishaSvet = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Klawisha#KlawishaSvet"));  
    
    self.KlawishaSvet1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Klawisha1#KlawishaSvet1")); 
    self.Awariika = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Awariika#AwariikaSvet"));   
	
	if self.isClient then
	    self.sampleHelloAcros = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.Hello", nil, self.baseDirectory);
	    self.sampleBunkerAlarm = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.bunkerAlarm", nil, self.baseDirectory);
	    self.sampleWarningSnek = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.WarningSnek", nil, self.baseDirectory);
		
        self.fruitExtraObjects = {};
        local i = 0;
        while true do
            local key = string.format("vehicle.fruitExtraObjects.fruitExtraObject(%d)", i);
            local t = getXMLString(self.xmlFile, key.."#fruitType");
            local index = getXMLString(self.xmlFile, key.."#index");
            local anim = getXMLString(self.xmlFile, key.."#anim");
            if t==nil or (index==nil and anim==nil) then
                break;
            end;

            local node = Utils.indexToObject(self.components, index);
            if node ~= nil then
                setVisibility(node, false);
            end;
            self.fruitExtraObjects[t] = {node=node, anim=anim};
            i = i +1;
        end;
        self.sampleThreshingNew = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.NewthreshingSound", nil, self.baseDirectory, self.components[1].node);
        if self.sampleThreshingNew ~= nil and self.sampleThreshingNew.sample ~= nil then
            self.sampleThreshingNew.cuttingPitchOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.NewthreshingSound#cuttingPitchOffset"), self.sampleThreshingNew.pitchOffset);
            self.sampleThreshingNew.lastCuttingPitchTime = 0;
            self.sampleThreshingNew.currentPitchOffset = self.sampleThreshingNew.pitchOffset;
        end
	end;
	
	local pedaltormozNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Acros.pedaltormoz#index"));
    if pedaltormozNode ~= nil then
        self.pedaltormoz = {};
        self.pedaltormoz.node = pedaltormozNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.Acros.pedaltormoz#minRot"));
        self.pedaltormoz.minRot = {};
        self.pedaltormoz.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.pedaltormoz.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.pedaltormoz.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.Acros.pedaltormoz#maxRot"));
        self.pedaltormoz.maxRot = {};
        self.pedaltormoz.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.pedaltormoz.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.pedaltormoz.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.pedaltormoz.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.Acros.pedaltormoz#rotTime"), 2)*1000;
    end;	
	
    local blinkerhebelNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.blinkerhebel#index"));
    if blinkerhebelNode ~= nil then
        self.blinkerhebel = {};
        self.blinkerhebel.node = blinkerhebelNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.blinkerhebel#minRot"));
        self.blinkerhebel.minRot = {};
        self.blinkerhebel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.blinkerhebel#rotLeft"));
        self.blinkerhebel.leftRot = {};
        self.blinkerhebel.leftRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.leftRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.leftRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.blinkerhebel#rotRight"));
        self.blinkerhebel.rightRot = {};
        self.blinkerhebel.rightRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.blinkerhebel.rightRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.blinkerhebel.rightRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.blinkerhebel.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.blinkerhebel#rotTime"), 1)*1000;
		self.blinkerhebel.lastDir = 1;
    end;
	
	local seatNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.seat#index"));
	if seatNode ~= nil then
		self.seat = {};
		self.seat.node = seatNode;
		self.seat.wheelId = getXMLInt(self.xmlFile, "vehicle.seat#wheelReferenceId") or 1;
		self.seat.usagePercentage = (getXMLInt(self.xmlFile, "vehicle.seat#usagePercentage") or 30) / 100;
		self.seat.offsetY = getXMLFloat(self.xmlFile, "vehicle.seat#offsetY");
	end;
    self.ShnekAnimation = getXMLString(self.xmlFile, "vehicle.ShnekAnimation#name");

end;

function RostselMash:delete()
    
    if self.isClient then
	    SoundUtil.deleteSample(self.sampleHelloAcros);
	    SoundUtil.deleteSample(self.sampleBunkerAlarm);
	    SoundUtil.deleteSample(self.sampleWarningSnek);
        SoundUtil.deleteSample(self.sampleThreshingNew);
    end;
end;

function RostselMash:readStream(streamId, connection)
end;

function RostselMash:writeStream(streamId, connection)
end;

function RostselMash:readUpdateStream(streamId, timestamp, connection)
end;

function RostselMash:writeUpdateStream(streamId, connection, dirtyMask)
end;

function RostselMash:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RostselMash:keyEvent(unicode, sym, modifier, isDown)
end;

function RostselMash:update(dt)
    local HelloEnableTimeStartDelay = 1;
	local HelloEnableTime = (self.motorStartTime - self.motorStartDuration) + HelloEnableTimeStartDelay;
	if self:getIsActive() and self.isMotorStarted then
        local speed = self.lastSpeed*3600;
        if self.gearShifter ~= nil then    
            if speed < 0.1 then
                setRotation(self.gearShifter, Utils.degToRad(0),   Utils.degToRad(0), Utils.degToRad(0));
	            setVisibility(self.U, true);
	            setVisibility(self.C, true);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, false);
	            setVisibility(self.CN, false);
	            setVisibility(self.ZN, false);
            else
			if speed >= 0.1 and speed < 11 then
                setRotation(self.gearShifter, Utils.degToRad(-17), Utils.degToRad(0), Utils.degToRad(-14));
	            setVisibility(self.U, false);
	            setVisibility(self.C, true);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, true);
	            setVisibility(self.CN, false);
	            setVisibility(self.ZN, false);
            elseif speed >= 11 and speed < 21 then
                setRotation(self.gearShifter, Utils.degToRad(-17), Utils.degToRad(0), Utils.degToRad(14));
	            setVisibility(self.U, true);
	            setVisibility(self.C, false);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, false);
	            setVisibility(self.CN, true);
	            setVisibility(self.ZN, false);
            elseif speed >= 21 and speed < 29 then
                setRotation(self.gearShifter, Utils.degToRad(17),  Utils.degToRad(0), Utils.degToRad(14));
	            setVisibility(self.U, true);
	            setVisibility(self.C, true);
	            setVisibility(self.Z, false);
	            setVisibility(self.UN, false);
	            setVisibility(self.CN, false);
	            setVisibility(self.ZN, true);
            elseif speed < -0.1 then
                setRotation(self.gearShifter, Utils.degToRad(0),   Utils.degToRad(0), Utils.degToRad(0));
	            setVisibility(self.U, true);
	            setVisibility(self.C, true);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, false);
	            setVisibility(self.CN, false);
	            setVisibility(self.ZN, false);
            elseif speed <= -0.1 and speed > -8 then
                setRotation(self.gearShifter, Utils.degToRad(-17), Utils.degToRad(0), Utils.degToRad(-14));
	            setVisibility(self.U, false);
	            setVisibility(self.C, true);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, true);
	            setVisibility(self.CN, false);
	            setVisibility(self.ZN, false);
            elseif speed <= -8 and speed > -12 then
                setRotation(self.gearShifter, Utils.degToRad(-17), Utils.degToRad(0), Utils.degToRad(14));
	            setVisibility(self.U, true);
	            setVisibility(self.C, false);
	            setVisibility(self.Z, true);
	            setVisibility(self.UN, false);
	            setVisibility(self.CN, true);
	            setVisibility(self.ZN, false);
            end;
        end;  
	end;
	    if self.pedaltormoz ~= nil then
		    local x, y, z = getRotation(self.pedaltormoz.node);
		    local rot = {x,y,z};
		    local newRot = Utils.getMovedLimitedValues(rot, self.pedaltormoz.maxRot, self.pedaltormoz.minRot, 3, self.pedaltormoz.rotTime, dt, self.brakeLightsVisibility);
		    setRotation(self.pedaltormoz.node, unpack(newRot));
	    end;
        if self.vehicleCharacter.isCharacterLoaded then
            for ikChainId, target in pairs(self.vehicleCharacter.ikChainTargets) do
                IKUtil.setTarget(self.vehicleCharacter.ikChains, ikChainId, target);
            end;
            self.vehicleCharacter:setCharacterDirty();
        end
		if self.seat ~= nil and self.wheels[self.seat.wheelId] ~= nil then
			if self.seat.trans == nil then
				self.seat.trans = {getTranslation(self.seat.node)};
				
				if self.seat.offsetY ~= nil then
					self.seat.trans[2] = self.seat.trans[2] + self.seat.offsetY;
				end;
			end;
			
			local _, y, _ = getTranslation(self.wheels[self.seat.wheelId].repr);
			local newTrans = (y * self.seat.usagePercentage) + self.seat.trans[2];
			newTrans = math.floor(newTrans * 40^95 + 0.5) / 40^95
			;
			
			if newTrans ~= self.seat.lastTrans then
				setTranslation(self.seat.node, self.seat.trans[1], newTrans, self.seat.trans[3]);
				self.seat.lastTrans = newTrans;
			end;
		end;
	end;

    if self:getIsActive() then
        if self.isClient then
		    if self:getIsActiveForSound() then
		        if (g_currentMission.time <= HelloEnableTime  and self.isMotorStarted) then
                    SoundUtil.playSample(self.sampleHelloAcros, 1, 0, nil);
		        else
                    self:playAnimation(self.Puskac, -1, nil, true);
		        end;
		    end;
            if self:getIsTurnedOn() then
                if self:getIsActiveForSound() then
                    if not SoundUtil.isSamplePlaying(self.sampleThreshingNewStart, 2.1*dt) then
                        SoundUtil.playSample(self.sampleThreshingNew, 0, 0, nil);
                    end
                    SoundUtil.stop3DSample(self.sampleThreshingNew);
                else
                    SoundUtil.play3DSample(self.sampleThreshingNew);
                end

                if self.sampleThreshingNew ~= nil and self.sampleThreshingNew.sample ~= nil and self.sampleThreshingNew.cuttingPitchOffset ~= nil then

                    for object,_ in pairs(self.attachedCutters) do
                        if object.lastCutterAreaBiggerZero == true then
                            self.sampleThreshingNew.lastCuttingPitchTime = g_currentMission.time;
                            break;
                        end
                    end

                    local pitchOffset = self.sampleThreshingNew.pitchOffset;

                    if (self.sampleThreshingNew.lastCuttingPitchTime + 700) > g_currentMission.time then
                        pitchOffset = self.sampleThreshingNew.cuttingPitchOffset;
                    end

                    local pitchDiff = math.abs(self.sampleThreshingNew.pitchOffset - self.sampleThreshingNew.cuttingPitchOffset);

                    if pitchOffset > self.sampleThreshingNew.currentPitchOffset then
                        self.sampleThreshingNew.currentPitchOffset = math.min(pitchOffset, self.sampleThreshingNew.currentPitchOffset + (0.00066 * dt * pitchDiff));
                    elseif pitchOffset < self.sampleThreshingNew.currentPitchOffset then
                        self.sampleThreshingNew.currentPitchOffset = math.max(pitchOffset, self.sampleThreshingNew.currentPitchOffset - (0.00066 * dt * pitchDiff));
                    end

                    SoundUtil.setSamplePitch(self.sampleThreshingNew, self.sampleThreshingNew.currentPitchOffset);
                end
            end
        end
    end
end;

function RostselMash:updateTick(dt) 

    local fruitDesc = FruitUtil.fruitIndexToDesc[self.lastValidInputFruitType];
    if self.isServer then
        if self.lastValidInputFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN and self.isClient then
            RostselMash.updateExtraObjects(self);
        end
    end
    if self:getIsActive() then
		if self.isMotorStarted then
            setVisibility(self.Comp, true);
            setVisibility(self.CompPribors, true);
        else
            setVisibility(self.Comp, false);
            setVisibility(self.CompPribors, false);
        end
    end

    if self:getIsActive() then
        if self.lightsTypesMask > 0 then
            setVisibility(self.NizSvet, false);
            setVisibility(self.NizSvet0, false);
            setVisibility(self.NizSvet1, false);
            setVisibility(self.NizSvet2, false);
            setVisibility(self.NizSvet3, false);
            setVisibility(self.NizSvet4, false);
            setVisibility(self.NizNSvet, true);
            setVisibility(self.NizNSvet0, true);
            setVisibility(self.NizNSvet1, true);
            setVisibility(self.NizNSvet2, true);
            setVisibility(self.NizNSvet3, true);
            setVisibility(self.NizNSvet4, true);
        else
            setVisibility(self.NizSvet, true);
            setVisibility(self.NizSvet0, true);
            setVisibility(self.NizSvet1, true);
            setVisibility(self.NizSvet2, true);
            setVisibility(self.NizSvet3, true);
            setVisibility(self.NizSvet4, true);
            setVisibility(self.NizNSvet, false);
            setVisibility(self.NizNSvet0, false);
            setVisibility(self.NizNSvet1, false);
            setVisibility(self.NizNSvet2, false);
            setVisibility(self.NizNSvet3, false);
            setVisibility(self.NizNSvet4, false);
        end;
        if self.camIndex == 2 then
            if (self.lightsTypesMask == 1)then
                setRotation(self.KlawishaSvet, 0, 0, Utils.degToRad(25));
            else
                setRotation(self.KlawishaSvet, 0, 0, Utils.degToRad(0));
            end;
            if (self.lightsTypesMask > 2)then
                setRotation(self.KlawishaSvet1, 0, 0, Utils.degToRad(7));
                setVisibility(self.NizNSvet5, true);
                setVisibility(self.NizNSvet7, false);
            else
                setRotation(self.KlawishaSvet1, 0, 0, Utils.degToRad(-2));
                setVisibility(self.NizNSvet5, false);
                setVisibility(self.NizNSvet7, true);
            end;
        end;
    end;
        if self.turnLightState ~= nil then
			if self.blinkerhebel ~= nil then
				local dir = 0;
				local hasRotChanged = false;
				local destRot = self.blinkerhebel.minRot;
				
				if self.turnLightState == 1 then
					destRot = self.blinkerhebel.leftRot;
					dir = 1;
				elseif self.turnLightState == 2 then
					destRot = self.blinkerhebel.rightRot;
					dir = -1;
				end
				if self.turnLightState == 3 then	    
			        setTranslation(self.Awariika, 0, math.abs(0), 0);
		        else
			        setTranslation(self.Awariika, 0, math.abs(-0.004), 0);
				end
				
				if self.blinkerhebel.lastDir ~= dir then
					self.blinkerhebel.lastDir = dir;
					self.blinkerhebel.rotatingTime = 0;
				end
				
				if self.blinkerhebel.rotatingTime ~= nil then
					self.blinkerhebel.rotatingTime = self.blinkerhebel.rotatingTime + dt;
					local t = math.min(1.0, self.blinkerhebel.rotatingTime / self.blinkerhebel.rotTime);
					if t == 1 then
						self.blinkerhebel.rotatingTime = nil;
					end
					local rot = {getRotation(self.blinkerhebel.node)};
					
					local rx1,ry1,rz1,rw1 = mathEulerToQuaternion(unpack(rot));
					local rx2,ry2,rz2,rw2 = mathEulerToQuaternion(unpack(destRot));
					
					local qx,qy,qz,qw = Utils.nlerpQuaternionShortestPath(rx1,ry1,rz1,rw1, rx2,ry2,rz2,rw2, t);
					setQuaternion(self.blinkerhebel.node, qx,qy,qz,qw);
				end
			end;
		end;

    if self.isClient then
	    if self:getIsTurnedOn() and self:getUnitFillLevel(self.overloading.fillUnitIndex) > (self:getUnitCapacity(self.overloading.fillUnitIndex) * 0.95) and self:getUnitFillLevel(self.overloading.fillUnitIndex) < (self:getUnitCapacity(self.overloading.fillUnitIndex) * 0.957) then
	        if self:getIsActiveForSound() then
	            SoundUtil.playSample(self.sampleBunkerAlarm, 0, 0, nil);
	        end;
	    else
	        SoundUtil.stopSample(self.sampleBunkerAlarm);
	    end;
        local speed = self.lastSpeed*3600;
	    if speed >= 0.1 and self:getUnitFillLevel(self.overloading.fillUnitIndex) > (self:getUnitCapacity(self.overloading.fillUnitIndex) * 0.02) and self.pipeTargetState == 2 then
	        if self:getIsActiveForSound() then
	            SoundUtil.playSample(self.sampleWarningSnek, 0, 0, nil);
	        end;
	    else
	        SoundUtil.stopSample(self.sampleWarningSnek);
	    end;
	end;

end;
function RostselMash.updateExtraObjects(self)
    if self.currentExtraObject ~= nil then
        if self.currentExtraObject.node ~= nil then
            setVisibility(self.currentExtraObject.node, false);
        end;
        if self.currentExtraObject.anim ~= nil and self.playAnimation ~= nil then
            self:playAnimation(self.currentExtraObject.anim, -1, self:getAnimationTime(self.currentExtraObject.anim), true);
        end
        self.currentExtraObject = nil;
    end;
    if self.lastValidInputFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
        local name = FruitUtil.fruitIndexToDesc[self.lastValidInputFruitType].name;
        local extraObject = self.fruitExtraObjects[name];
        if extraObject ~= nil then
            if extraObject.node ~= nil then
                setVisibility(extraObject.node, true);
            end;
            if extraObject.anim ~= nil and self.playAnimation ~= nil then
                self:playAnimation(extraObject.anim, 1, self:getAnimationTime(extraObject.anim), true);
            end
            self.currentExtraObject = extraObject;
        end;
    end;
end;
function RostselMash:draw()
end;

function RostselMash:onLeave()
end;

function RostselMash:onEnter()
end;
function RostselMash:startThreshing()
end;
function RostselMash:stopThreshing()
    if self.isClient then
        SoundUtil.stopSample(self.sampleThreshingNew, true);
        SoundUtil.stop3DSample(self.sampleThreshingNew);
	end;
end

function RostselMash:onDeactivateSounds()
    if self.isClient then
        SoundUtil.stopSample(self.sampleThreshingNew, true);
	end;
end;
function RostselMash:onTurnedOn(noEventSend)
    self:startThreshing();
end